--------------------------------------------------------------------------------
-- Company: 
-- Engineer:mhigashiyama
--
-- Create Date:   15:39:26 08/09/2015
-- Design Name:   a
-- Module Name:   Sound.vhd     
-- Project Name:  Sound
-- Target Device:  
-- Tool versions:  ISE
-- Description:   
--
---------------------------------------------------------------------------
--  Modification History:                                                  
--  Date        By         Version  Change      Description                
---------------------------------------------------------------------------
--  2015.8.10  mhigashiyama      0.00  Orignal                             
--------------------------------------------------------------------------------



--pbP[WĂяo
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.ALL;



--GeBeBio͂̐錾j
--OƂ̃C^[tF[XLqB
--H}́uV{vɑB
ENTITY Sound is
	PORT(
	Reset			:	in std_logic;		--BTN_SOUTH{^Reset|
	CLK_50MHz		:	in std_logic;

--SPo̓C^[tF[X

	OUT_261			:	out std_logic;
	OUT_293			:	out std_logic;
	OUT_329			:	out std_logic;
	OUT_349			:	out std_logic;
	OUT_392			:	out std_logic;
	OUT_440			:	out std_logic;
	OUT_493			:	out std_logic;
	OUT_523			:	out std_logic;

	SW_261			:	in std_logic;
	SW_293			:	in std_logic;
	SW_329			:	in std_logic;
	SW_349			:	in std_logic;
	SW_392			:	in std_logic;
	SW_440			:	in std_logic;
	SW_493			:	in std_logic;
	SW_523			:	in std_logic

	);
END Sound;


--A[LeN`
--̓Lq(H̖{)
ARCHITECTURE rtl OF Sound IS

signal Count_261		: std_logic_vector(19 downto 0);
signal Count_293		: std_logic_vector(19 downto 0);
signal Count_329		: std_logic_vector(19 downto 0);
signal Count_349		: std_logic_vector(19 downto 0);
signal Count_392		: std_logic_vector(19 downto 0);
signal Count_440		: std_logic_vector(19 downto 0);
signal Count_493		: std_logic_vector(19 downto 0);
signal Count_523		: std_logic_vector(19 downto 0);

signal SW_261_1Latch	: std_logic;
signal SW_293_1Latch	: std_logic;
signal SW_329_1Latch	: std_logic;
signal SW_349_1Latch	: std_logic;
signal SW_392_1Latch	: std_logic;
signal SW_440_1Latch	: std_logic;
signal SW_493_1Latch	: std_logic;
signal SW_523_1Latch	: std_logic;

signal SW_261_2Latch	: std_logic;
signal SW_293_2Latch	: std_logic;
signal SW_329_2Latch	: std_logic;
signal SW_349_2Latch	: std_logic;
signal SW_392_2Latch	: std_logic;
signal SW_440_2Latch	: std_logic;
signal SW_493_2Latch	: std_logic;
signal SW_523_2Latch	: std_logic;



BEGIN


--XCb`͐M̂Piڃb`H
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			SW_261_1Latch <= '1';
			SW_293_1Latch <= '1';
			SW_329_1Latch <= '1';
			SW_349_1Latch <= '1';
			SW_392_1Latch <= '1';
			SW_440_1Latch <= '1';
			SW_493_1Latch <= '1';
			SW_523_1Latch <= '1';
		else
			SW_261_1Latch <= SW_261;
			SW_293_1Latch <= SW_293;
			SW_329_1Latch <= SW_329;
			SW_349_1Latch <= SW_349;
			SW_392_1Latch <= SW_392;
			SW_440_1Latch <= SW_440;
			SW_493_1Latch <= SW_493;
			SW_523_1Latch <= SW_523;
		end if;
	end if;
end process;


--XCb`͐M2iڃb`H
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			SW_261_2Latch <= '1';
			SW_293_2Latch <= '1';
			SW_329_2Latch <= '1';
			SW_349_2Latch <= '1';
			SW_392_2Latch <= '1';
			SW_440_2Latch <= '1';
			SW_493_2Latch <= '1';
			SW_523_2Latch <= '1';
		else
			SW_261_2Latch <= SW_261_1Latch;
			SW_293_2Latch <= SW_293_1Latch;
			SW_329_2Latch <= SW_329_1Latch;
			SW_349_2Latch <= SW_349_1Latch;
			SW_392_2Latch <= SW_392_1Latch;
			SW_440_2Latch <= SW_440_1Latch;
			SW_493_2Latch <= SW_493_1Latch;
			SW_523_2Latch <= SW_523_1Latch;
		end if;
	end if;
end process;



-----------------------------------------------
--261HzihjpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_261 <= (others=>'0');
		elsif(SW_261_2Latch = '1') then
			Count_261 <= X"2EA9A";
		elsif(Count_261 >= X"2EA9A") then
			Count_261 <= (others=>'0');
		else
			Count_261 <= Count_261 + 1;
		end if;
	end if;
end process;



--261HzihjpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			OUT_261 <= '0';
		elsif(SW_261_2Latch = '1') then
			OUT_261 <= '0';
		elsif(Count_261 >= X"00000" and Count_261 <= X"0BAA5") then
			OUT_261 <= '1';
		else
			OUT_261 <= '0';
		end if;
	end if;
end process;



-----------------------------------------------
--293HzijpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_293 <= (others=>'0');
		elsif(SW_293_2Latch = '1') then
			Count_293 <= X"29900";
		elsif(Count_293 >= X"29900") then
			Count_293 <= (others=>'0');
		else
			Count_293 <= Count_293 + 1;
		end if;
	end if;
end process;


--293HzijpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			OUT_293 <= '0';
		elsif(Count_293 >= X"00000" and Count_293 <= X"0A63F") then
			OUT_293 <= '1';
		else
			OUT_293 <= '0';
		end if;
	end if;
end process;




-----------------------------------------------
--329Hzi~jpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_329 <= (others=>'0');
		elsif(SW_329_2Latch = '1') then
			Count_329 <= X"25092";
		elsif(Count_329 >= X"25092") then
			Count_329 <= (others=>'0');
		else
			Count_329 <= Count_329 + 1;
		end if;
	end if;
end process;


--329Hzi~jpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			OUT_329 <= '0';
		elsif(Count_329 >= X"00000" and Count_329 <= X"09423") then
			OUT_329 <= '1';
		else
			OUT_329 <= '0';
		end if;
	end if;
end process;




-----------------------------------------------
--349Hzit@jpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_349 <= (others=>'0');
		elsif(SW_349_2Latch = '1') then
			Count_349 <= X"22F4F";
		elsif(Count_349 >= X"22F4F") then
			Count_349 <= (others=>'0');
		else
			Count_349 <= Count_349 + 1;
		end if;
	end if;
end process;


--349Hzit@jpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			OUT_349 <= '0';
		elsif(Count_349 >= X"00000" and Count_349 <= X"08BD3") then
			OUT_349 <= '1';
		else
			OUT_349 <= '0';
		end if;
	end if;
end process;




-----------------------------------------------
--392Hzi\jpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_392 <= (others=>'0');
		elsif(SW_392_2Latch = '1') then
			Count_392 <=  X"1F23E";
		elsif(Count_392 >= X"1F23E") then
			Count_392 <= (others=>'0');
		else
			Count_392 <= Count_392 + 1;
		end if;
	end if;
end process;


--392Hzi\jpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Out_392 <= '0';
		elsif(Count_392 >= X"00000" and Count_392 <= X"07C8E") then
			Out_392 <= '1';
		else
			Out_392 <= '0';
		end if;
	end if;
end process;






-----------------------------------------------
--440HzijpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_440 <= (others=>'0');
		elsif(SW_440_2Latch = '1') then
			Count_440 <=  X"1BBE3";
		elsif(Count_440 >= X"1BBE3") then
			Count_440 <= (others=>'0');
		else
			Count_440 <= Count_440 + 1;
		end if;
	end if;
end process;


--440HzijpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Out_440 <= '0';
		elsif(Count_440 >= X"00000" and Count_440 <= X"06EF8") then
			Out_440 <= '1';
		else
			Out_440 <= '0';
		end if;
	end if;
end process;






-----------------------------------------------
--493HziVjpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_493 <= (others=>'0');
		elsif(SW_493_2Latch = '1') then
			Count_493 <= X"18B72";
		elsif(Count_493 >= X"18B72") then
			Count_493 <= (others=>'0');
		else
			Count_493 <= Count_493 + 1;
		end if;
	end if;
end process;


--493HziVjpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Out_493 <= '0';
		elsif(Count_493 >= X"00000" and Count_493 <= X"062DB") then
			Out_493 <= '1';
		else
			Out_493 <= '0';
		end if;
	end if;
end process;




-----------------------------------------------
--523HzihjpJE^[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Count_523 <= (others=>'0');
		elsif(SW_523_2Latch = '1') then
			Count_523 <= X"18B72";
		elsif(Count_523 >= X"1753A") then
			Count_523 <= (others=>'0');
		else
			Count_523 <= Count_523 + 1;
		end if;
	end if;
end process;


--523HzihjpfR[_[
process(CLK_50MHz)begin
	if(CLK_50MHz'event and CLK_50MHz='1')then
		if(Reset='1')then
			Out_523 <= '0';
		elsif(Count_523 >= X"00000" and Count_523 <= X"05D4D") then
			Out_523 <= '1';
		else
			Out_523 <= '0';
		end if;
	end if;
end process;



END rtl;

